package edu.byu.hbll.callnumber;

import java.math.BigDecimal;
import java.util.Objects;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * CallNumber implementation representing a Dewey (DCC) call number.
 *
 * <p>In addition to satisfying the requirements of the CallNumber interface, DeweyCallNumber also
 * attempts to parse the various components of a DCC call number and make them available discretely
 * through class-specific methods.
 *
 * <p>See https://www.oclc.org/dewey for information about the underlying classification scheme.
 */
public final class DeweyCallNumber implements CallNumber {

  /** Serialization version. */
  private static final long serialVersionUID = 1L;

  /** The regular expression used to parse an LC Call Number into its component values. */
  public static final Pattern DEWEY_CALLNUMBER_PATTERN =
      Pattern.compile(
          "^\\s*(\\d{3})(?:\\.(\\d+))?"
              + "(?:\\s*([A-Z]+)(\\d+):?(\\w*))?"
              + "(?:\\s+([A-Z]+)(\\d+)(\\w*))?"
              + "(?:\\s+([A-Z]+)(\\d+)(\\w*))?"
              + "(?:\\s+(.+)\\s*)?$",
          Pattern.CASE_INSENSITIVE);

  /** The subject class of the call number. */
  private final BigDecimal subjectNumber;

  /** The first cutter. */
  private final String cutter1;

  /** The second cutter. */
  private final String cutter2;

  /** The third cutter. */
  private final String cutter3;

  /** All text following the cutters. */
  private final String postCutter;

  /** The human-friendly normalized representation of the Dewey call number. */
  private final String normalization;

  /** The (not-human-friendly) sortable representation of the Dewey call number. */
  private final String sortKey;

  /**
   * Constructs a new instance using the provided string as the template.
   *
   * @param str the call number string to use as the template (note that this should be a normalized
   *     or semi-normal representation of an Dewey Call Number, NOT a sortKey generated by an
   *     existing LCCallNumber instance).
   * @throws NullPointerException if the provided string is null
   * @throws IllegalArgumentException if the provided string cannot be parsed as an LC Call Number.
   */
  public DeweyCallNumber(String str) throws NullPointerException, IllegalArgumentException {
    Objects.requireNonNull(str);
    // Make sure that we are parsing something that looks like an Dewey call number and capture the
    // groups
    Matcher matcher = DEWEY_CALLNUMBER_PATTERN.matcher(str);
    if (!matcher.matches()) {
      throw new IllegalArgumentException("does not match Dewey Call Number pattern: " + str);
    }

    // Construct the subject number as a decimal value
    String subjectWholeNumber = CallNumberUtil.nullableTrim(matcher.group(1));
    String subjectDecimalNumber = CallNumberUtil.nullableTrim(matcher.group(2));
    this.subjectNumber =
        subjectDecimalNumber.isEmpty()
            ? new BigDecimal(subjectWholeNumber)
            : new BigDecimal(subjectWholeNumber + "." + subjectDecimalNumber);

    // The first cutter usually begins with a dot followed by a letter and several numbers,
    // but in reality there are a variety of different forms it can take
    this.cutter1 =
        CallNumberUtil.nullableTrimAndConcat(matcher.group(3), matcher.group(4), matcher.group(5));

    // Second cutter
    this.cutter2 =
        CallNumberUtil.nullableTrimAndConcat(matcher.group(6), matcher.group(7), matcher.group(8));

    // Third cutter
    this.cutter3 =
        CallNumberUtil.nullableTrimAndConcat(
            matcher.group(9), matcher.group(10), matcher.group(11));

    // An unstructured data set may follow after zero or more cutters
    String postCutter = CallNumberUtil.nullableTrim(matcher.group(12));
    this.postCutter = postCutter;

    // Once all the class values are set, we can build the response values for the toString
    // and toNormalizedString methods.  Since this class is immutable, we can do this at
    // construction time to make those methods less expensive.
    this.normalization = buildNormalization();
    this.sortKey = buildSortKey();
  }

  /**
   * Builds and returns the normalized string representation of the call number.
   *
   * @return the normalized string representation
   */
  private String buildNormalization() {
    StringBuilder normalization = new StringBuilder(subjectNumber.toString());

    if (!cutter1.isEmpty()) {
      normalization.append(" ").append(cutter1);
    }
    if (!cutter2.isEmpty()) {
      normalization.append(" ").append(cutter2);
    }
    if (!cutter3.isEmpty()) {
      normalization.append(" ").append(cutter3);
    }
    if (!postCutter.isEmpty()) {
      normalization.append(" ").append(postCutter);
    }

    return normalization.toString();
  }

  /**
   * Builds and returns the sortable string representation of the call number.
   *
   * @return the sortable string representation
   */
  private String buildSortKey() {
    StringBuilder sortKey =
        new StringBuilder(CallNumberUtil.NUMBER_FORMATTER.format(subjectNumber));

    if (!cutter1.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter1));
    }
    if (!cutter2.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter2));
    }
    if (!cutter3.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter2));
    }
    if (!postCutter.isEmpty()) {
      String formattedPostCutter =
          this.postCutter
              .replaceAll("(^|\\W)(\\d+)(\\W|$)", "$1\\0000000000000000$2$3")
              .replaceAll("(^|\\W)00000000+?(\\d{6}+)(\\W|$)", "$1$2$3");
      sortKey.append(" ").append(formattedPostCutter);
    }

    // It is my understanding that non-Latin characters should never be used in Dewey Call Numbers.
    // However, if
    // they are allowed, replacing the return statement with the commented line below should sort
    // them properly.
    // return Normalizer.normalize(sortKey.toString().toLowerCase(), Normalizer.Form.NFD);
    return sortKey.toString().toLowerCase();
  }

  /**
   * Formats a cutter string to drop any trailing letters so that they sort before numbers (contrary
   * to normal String sorting rules).
   *
   * @param cutter the cutter string to format
   * @return the formatted cutter
   */
  private String buildSortableCutter(String cutter) {
    return cutter.replaceAll("^(\\w+?)(\\d+)(\\w*)$", "$1$2/$3");
  }

  @Override
  public int compareTo(CallNumber other) {
    return sortKey().compareTo(other.sortKey());
  }

  @Override
  public String sortKey() {
    return sortKey;
  }

  @Override
  public String toString() {
    return normalization;
  }

  @Override
  public int hashCode() {
    return sortKey.hashCode();
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (obj == null || getClass() != obj.getClass()) {
      return false;
    }
    return Objects.equals(sortKey, ((CallNumber) obj).sortKey());
  }

  /**
   * Returns the subject number.
   *
   * @return the subject number
   */
  public BigDecimal getSubjectNumber() {
    return subjectNumber;
  }

  /**
   * Returns the first cutter.
   *
   * @return the first cutter
   */
  public String getCutter1() {
    return cutter1;
  }

  /**
   * Returns the second cutter.
   *
   * @return the second cutter
   */
  public String getCutter2() {
    return cutter2;
  }

  /**
   * Returns the third cutter.
   *
   * @return the third cutter
   */
  public String getCutter3() {
    return cutter3;
  }

  /**
   * Returns any text that follows the cutter.
   *
   * @return the post-cutter text
   */
  public String getPostCutter() {
    return postCutter;
  }
}
